<?php
/**
 * Created by IntelliJ IDEA.
 * User: Administrator
 * Date: 2020/9/5 0005
 * Time: 0:37
 */

namespace extend\service;

use app\super\model\BsysConfig;
use dh2y\sms\service\Jianzhou;
use Flc\Dysms\Client;
use Flc\Dysms\Request\SendSms;

class SmsService
{
    public static function sendAliMsg($mobile, $type = '', $code = '')
    {
        //查询key直接发
        $config = BsysConfig::getAllVal('sms_config');
        if (!$config) return JsonDataService::fail('短信未配置');
        $code = $code ? $code : rand(100000, 999999);
        $key = ConfigService::SMS_CODE . $type . ':' . $mobile;
//        if (RedisService::get($key)) return JsonDataService::fail('60秒后重新发送!');
//        $ali_config = [
//            'accessKeyId' => $config['sms_appkey'],
//            'accessKeySecret' => $config['sms_appScript'],
//        ];
//        $client = new Client($ali_config);
//        $sendSms = new SendSms;
//        $sendSms->setPhoneNumbers($mobile);
//        $sendSms->setSignName($config['sms_sign']);
//        $sendSms->setTemplateCode($config['sms_code']);
//
//        $sendSms->setTemplateParam(['code' => $code]);
//        $res = $client->execute($sendSms);
//        $res = (array)$res;
        $statusStr = array(
            "0" => "短信发送成功",
            "-1" => "参数不全",
            "-2" => "服务器空间不支持,请确认支持curl或者fsocket，联系您的空间商解决或者更换空间！",
            "30" => "密码错误",
            "40" => "账号不存在",
            "41" => "余额不足",
            "42" => "帐户已过期",
            "43" => "IP地址限制",
            "50" => "内容含有敏感词"
        );
        $smsapi = "http://api.smsbao.com/";
        $user = $config['sms_appkey']; //短信平台帐号
        $pass = md5($config['sms_appScript']); //短信平台密码
        $content= '【'.$config['sms_sign'].'】'.str_replace('{$code}',$code,$config['sms_code']);//要发送的短信内容
        $phone = $mobile;//要发送短信的手机号码
        $sendurl = $smsapi."sms?u=".$user."&p=".$pass."&m=".$phone."&c=".urlencode($content);
        $result =file_get_contents($sendurl) ;
        if ($result != 0) {
            return JsonDataService::fail('短信发送失败!'.$statusStr[$result], $result);
        }
        //缓存
        if ($type) RedisService::setex($key, $code, 300);
        return JsonDataService::success('短信发送成功!', ['code' => $code, 'key' => $key]);
    }

    /**
     * 校验验证码
     */
    public static function checkSsmCode($params)
    {
        $key = ConfigService::SMS_CODE.$params['type'].':'.$params['mobile'];
        $code = RedisService::get($key);
        if(!$code) return JsonDataService::fail('验证码已失效，请重新获取');
        if($params['code'] !=$code) return JsonDataService::fail('验证码不正确!');
        return JsonDataService::success('校验通过!');
    }
}